<script>
import appConfig from '@src/app.config.json'
import Layout from '@layouts/main'
import ChatSidebar from "@components/chat/chat-sidebar";
import ChatContentMessage from "@components/chat/chat-content-messages";
import Empty from "@components/utils/empty-content";
import Message from "@src/models/chat/Message";
import store from "@state/store";

export default {
  page: {
    title: 'Messagerie',
    meta: [{ name: 'description', content: appConfig.description }],
  },
  components: { Layout, ChatSidebar, ChatContentMessage, Empty },
  data() {
    return {
      title : 'Messagerie',
      currentSpokesPerson : null,
      messages : null,
      currentMessage : null
    }
  },
  methods : {
    changeCurrentSpokesPerson(currentSpokesPerson) {
      this.currentSpokesPerson = currentSpokesPerson;
      this.loadMessages();
      this.initMessage();
    },
    async loadMessages() {
      this.messages = await this.$store.dispatch('message/getConversation', { user_id : this.currentSpokesPerson.user.id })
    },
    initMessage() {
      this.currentMessage = new Message({content : '', author : store.state.auth.currentUser, author_id : store.state.auth.currentUser.user.id, recipient_id : this.currentSpokesPerson.user.id})
    },
  }
}
</script>

<template>
  <Layout :title="title">
    <div class="row">
      <div class="col-xl-3 col-lg-4">
        <chat-sidebar @changeCurrentSpokesPerson="changeCurrentSpokesPerson"></chat-sidebar>
      </div>
      <div class="col-xl-9 col-lg-8">
        <chat-content-message
          v-if="currentSpokesPerson"
          :messages="messages"
          :currentSpokesPerson="currentSpokesPerson"
          :currentMessage="currentMessage"
          @sentMessage="initMessage"
        ></chat-content-message>
        <empty v-else title="Choisissez une conversation" icon="<i class='far fa-comments'></i>"></empty>
      </div>
    </div>
  </Layout>
</template>

